#ifdef __MQL5__

class BENCHMARK
{
private:

#endif // __MQL5__

  struct BENCHMARK_STRUCT
  {
    ulong StartTime;
    string Str;

    void Set( const string &sStr )
    {
      this.Str = sStr;
      StartTime = ::GetMicrosecondCount();

      return;
    }

    ulong Get( void ) const
    {
      return(::GetMicrosecondCount() - this.StartTime);
    }
  };

#ifndef __MQL5__

class BENCHMARK
{
private:

#endif // __MQL5__

  static BENCHMARK_STRUCT Bench[];

public:
  static bool Set( const string Str )
  {
    BENCHMARK::Bench[::ArrayResize(BENCHMARK::Bench, ::ArraySize(BENCHMARK::Bench) + 1) - 1].Set(Str);

    return(true);
  }

  static ulong Get( const uint AlertInterval = 0 )
  {
    const int Pos = ::ArraySize(BENCHMARK::Bench) - 1;
    const ulong Res = (Pos < 0) ? 0 : BENCHMARK::Bench[Pos].Get();

    if (Pos >= 0)
    {
      if (AlertInterval && (Res > AlertInterval))
        ::Alert("Time[" + BENCHMARK::Bench[Pos].Str + "] = " + (string)Res + " ms.");

      ::ArrayResize(BENCHMARK::Bench, Pos);
    }

    return(Res);
  }

  template <typename T>
  static T Benchmark( const ulong Get, const T FuncValue, const bool Set )
  {
    return(FuncValue);
  }

  template <typename T>
  static T Benchmark( const ulong Get, const T &FuncValue, const bool Set )
  {
    return(FuncValue);
  }
};

#ifdef __MQL5__
  static BENCHMARK::BENCHMARK_STRUCT BENCHMARK::Bench[];
#else // __MQL5__
  static BENCHMARK_STRUCT BENCHMARK::Bench[];
#endif // __MQL5__

// void
#define _BV(A,B)                                                 \
{                                                                \
  BENCHMARK::Set(__FILE__ + " " + (string)__LINE__ + ": " + #A); \
  A;                                                             \
  BENCHMARK::Get(B);                                             \
}

// Not void
#define _B(A,B) ((B) ? BENCHMARK::Benchmark(BENCHMARK::Get(B), A, BENCHMARK::Set(__FILE__ + " " + (string)__LINE__ + ": " + #A)) : A)